#!/usr/bin/env python
from twisted.internet import reactor, protocol, defer, task # extra dep twisted
from twisted.protocols import basic

import ConfigParser
import os
import time
import binascii
from Crypto.Cipher import Blowfish  # Extra dep pycrypto
import elements # extra dep pyp

class CrypTo:
	def __init__(self,key):
		self.crypt = Blowfish.new(key)
		
	def encrypt(self, line):
		line = self.fixlength(line)
		line = self.crypt.encrypt(line)
		line = binascii.b2a_hex(line)
		return line
			
	def decrypt(self, line):
		# Guess what i decrypt stuff.
		line = binascii.a2b_hex(line.strip())
		line = self.crypt.decrypt(line)
		line = line.replace('\n','') # Remove extra chars
		data = line.split('\r')
		return data

	def fixlength(self, line):
		# I will fix the length of the string.
		# So we wont have any odders ;)
		length = len(line)
		for max in range(1, 51):
			if length <= 8*max:
				add = (8*max) - length
				break
		extra = '\n'
		line += extra*add
		return line
		
class MenotProtocol(basic.LineReceiver):
	delimiter = '\n'

	def connectionMade(self):
		print "connected to %s" % host
	        timedrequest.start(intervall) # start after connection is made
		if show_connect == 1:
			self.send("%s enters the cave" % nick,0)
		
	def lineReceived(self, line):
		self.handler(line)

	def connectionLost(self, reason):
		print "lost connection"

	def handler(self, line):
		line = crypt.decrypt(line)
		if line[0] == "00": # Handle public bubble
			mfrom, msg = line[1].split(': ',1)
			window.show_data(msg,mfrom)
		elif line[0] == "01": # Handle wisper
			cryp = CrypTo(nick)
			msg = line[1]
			msg = cryp.decrypt(msg)
			msg = msg[0]
			if msg[:1] == '+':
				msg = msg[1:]
				tmp,msg = msg.split(':')
				msg = msg[1:]
				window.show_data(msg)

	def send(self, line):
		line = crypt.encrypt(line)
		if (len(line)%2)==0:
			self.sendLine(line)

class MenotFactory(protocol.ClientFactory):
	def buildProtocol(self, addr):
		global protocol
		protocol = MenotProtocol()
		return protocol

	def clientConnectionFailed(self, connectior, reason):
		print "Connection failed:", reason.getErrorMessage()
		reactor.stop()

	def clientConnectionLost(self, connectior, reason):
		print "Connection lost:", reason.getErrorMessage()
		reactor.stop()

	def send(self, line, type, to="none"):
		if type == 0:
			line = "0%i\r%s: %s" %(type, nick, line)
			protocol.send(line)
		elif type == 1:
			line = "%s: %s" %(nick, line)
			cryp = CrypTo(to)
			line = cryp.encrypt(line)
			line = "0%i\r%s" %(type, line)
			protocol.send(line)

class MainWindow:
	def destroy(self, widget, data=None):
		reactor.stop()
		os._exit(0)

	def show_data(self, data, mfrom):
		# store reviced uptime in the buffer
		if mfrom[-7:] == "updemon":
			ibuffer.append("%s: %s" %(mfrom[:-8],data))

def requestUpTimes():
	# request the new uptime's and kill the old buffer.
	if len(ibuffer) != 0:
		for item in range(0,len(ibuffer) ):
			ibuffer.pop()
	factory.send("get uptimes",0)
        timedelay = reactor.callLater(renderdelay, renderPage)

def renderPage():
	# later on this will render a page
	htmlstring = str()
	for uptimex in ibuffer:
		htmlstring += "%s\n" % uptimex
	gentime = time.localtime() # generate a nice time stamp :)
	filteredtime = "%i-%i-%i %i:%i:%i" %(gentime[0],gentime[1],gentime[2],gentime[3],gentime[4],gentime[5])
	htmlstring = "Generated: %s\n%s" %(filteredtime,htmlstring)
	# generate the page (yepp the pyp way ;) ):
	htmlcode = elements.html_start(title,css)
	htmlcode = htmlcode.replace('Content-Type: text/html','')
	htmlcode += elements.title(title)
	htmlcode += elements.element(htmlstring,"Regenerates every 30m, show only online computer's that runs the menot-updemon")
	htmlcode += elements.footer("<a href=\"/\">Return to mainpage</a>")
	htmlcode += elements.html_end()

	# remove the page on the server and store the new.
	try:
		os.remove(htmloutput)
	except:
		print "no old file found..."
	fileh = open(htmloutput,'w')
	fileh.write(htmlcode)
	fileh.close()
	print "done, file saved"

if __name__ == '__main__':
	global window
	global factory

	config = ConfigParser.ConfigParser()
	config.read("./menot-upreq.conf")
	host = config.get("server","host")
	port = config.getint("server","port")
	nick = config.get("user","nick")
	key = config.get("user","key")
	intervall = config.getint("request","intervall")
	renderdelay = config.getint("request","renderdelay")
	htmloutput = config.get("html","output")
	title = config.get("html","title")
	css = config.get("html","css")
	show_connect = config.getint("user","show_connect")
	ibuffer = list()
	
	crypt = CrypTo(key)
	window = MainWindow()
	factory = MenotFactory()
	timedrequest = task.LoopingCall(requestUpTimes)
	reactor.connectTCP(host, port, factory)
	reactor.run()
