#!/usr/bin/env python
from twisted.internet import reactor, protocol, defer # extra dep twisted
from twisted.protocols import basic

import ConfigParser
import os
import time
import binascii
from Crypto.Cipher import Blowfish  # Extra dep pycrypto

class CrypTo:
	def __init__(self,key):
		self.crypt = Blowfish.new(key)
		
	def encrypt(self, line):
		line = self.fixlength(line)
		line = self.crypt.encrypt(line)
		line = binascii.b2a_hex(line)
		return line
			
	def decrypt(self, line):
		# Guess what i decrypt stuff.
		line = binascii.a2b_hex(line.strip())
		line = self.crypt.decrypt(line)
		line = line.replace('\n','') # Remove extra chars
		data = line.split('\r')
		return data

	def fixlength(self, line):
		# I will fix the length of the string.
		# So we wont have any odders ;)
		length = len(line)
		for max in range(1, 51):
			if length <= 8*max:
				add = (8*max) - length
				break
		extra = '\n'
		line += extra*add
		return line
		
class MenotProtocol(basic.LineReceiver):
	delimiter = '\n'

	def connectionMade(self):
		print "connected to %s" % host
		if show_connect == 1:
			self.send("%s enters the cave" % nick,0)
		
	def lineReceived(self, line):
		self.handler(line)

	def connectionLost(self, reason):
		print "lost connection"

	def handler(self, line):
		line = crypt.decrypt(line)
		if line[0] == "00": # Handle public bubble
			mfrom, msg = line[1].split(': ',1)
			window.show_data(msg,mfrom)
		elif line[0] == "01": # Handle wisper
			cryp = CrypTo(nick)
			msg = line[1]
			msg = cryp.decrypt(msg)
			msg = msg[0]
			if msg[:1] == '+':
				msg = msg[1:]
				tmp,msg = msg.split(':')
				msg = msg[1:]
				window.show_data(msg)

	def send(self, line):
		line = crypt.encrypt(line)
		if (len(line)%2)==0:
			self.sendLine(line)

class MenotFactory(protocol.ClientFactory):
	def buildProtocol(self, addr):
		global protocol
		protocol = MenotProtocol()
		return protocol

	def clientConnectionFailed(self, connectior, reason):
		print "Connection failed:", reason.getErrorMessage()
		reactor.stop()

	def clientConnectionLost(self, connectior, reason):
		print "Connection lost:", reason.getErrorMessage()
		reactor.stop()

	def send(self, line, type, to="none"):
		if type == 0:
			line = "0%i\r%s: %s" %(type, nick, line)
			protocol.send(line)
		elif type == 1:
			line = "%s: %s" %(nick, line)
			cryp = CrypTo(to)
			line = cryp.encrypt(line)
			line = "0%i\r%s" %(type, line)
			protocol.send(line)

class MainWindow:
	def destroy(self, widget, data=None):
		reactor.stop()
		os._exit(0)

	def show_data(self, data, mfrom):
		#print "'%s': \"%s\"" %(mfrom,data)
		if data == "get uptimes":
			uptime = os.popen("uptime")
			msg = uptime.read()
			uptime.close()
			msg.strip()
			msg = msg[1:]
			uptime = msg.split(',')
			msg = "%s,%s,%s,%s,%s" %(uptime[0],uptime[1],uptime[3],uptime[4],uptime[5])
			factory.send(msg,0)#mfrom)

if __name__ == '__main__':
	global window
	global factory

	config = ConfigParser.ConfigParser()
	config.read("./menot-updemon.conf")
	host = config.get("server","host")
	port = config.getint("server","port")
	nick = config.get("user","nick")
	key = config.get("user","key")
	show_connect = config.getint("user","show_connect")

	crypt = CrypTo(key)
	window = MainWindow()
	factory = MenotFactory()
	reactor.connectTCP(host, port, factory)
	reactor.run()
