#!/usr/bin/env python

from twisted.internet import reactor, protocol
from twisted.protocols import basic

class ChatProtocol(basic.LineReceiver):
	def connectionMade(self):
		print "A client connected"
	
	def dataReceived(self, data):
		data = str(data).strip()
		self.factory.sendLine(data)
	
	def connectionLost(self, reason):
		print "A client disconnected"
		self.factory.cli_list.remove(self)

class ChatFactory(protocol.ServerFactory):
	cli_list = []

	def buildProtocol(self, addr):
		p = ChatProtocol()
		p.factory = self
		self.cli_list.append(p)
		return p

	def sendLine(self, data):
		for client in self.cli_list:
			client.sendLine(data)

if __name__ == '__main__':
	reactor.listenTCP(6978, ChatFactory())
	try:
		print "menot server v0.2"
		reactor.run()
	except KeybordInterrupt:
		reactor.stop()
